import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.*;


public class listenerApplet extends Applet{

    public static String portnumberParam   = "portnumber";
    public static String netaddressParam   = "netaddress";

    private Label titleLabel;
    private MultilineClientFrame myFrame;
    private int portnumber = 6699;
    private String netaddress = "244.0.0.0";
    private int windowWidth = 0;
    private int windowHeight = 0;

	public static DatagramSocket socket;
	public static DatagramPacket packet;
	public static InetAddress address;

    public String getAppletInfo(){
		return ("WhozzCalling Listener Java Applet Implementation 0.1b by CallerID.com");
    }
    

    public String[][] getParameterInfo(){
		String[][] args = {
		    { portnumberParam, "string", "Port to listen for data on" },
		    { netaddressParam, "string", "Localized network address to listen for data on" },
		};
		return (args);
	}

    
    public void init(){
		if (getParameter(portnumberParam) != null)
		    portnumber = Integer.parseInt(getParameter(portnumberParam));
	
		if (getParameter(netaddressParam) != null)
		    netaddress = getParameter(netaddressParam);
		return;
    }


    public void start(){
		myFrame = new MultilineClientFrame(null, true, "applet");
		myFrame.show();
		myFrame.updateWindow("WhozzCalling Listener Client Applet started.");
		myFrame.updateWindow("Connecting to server " + netaddress + ":" + portnumber + "...");
		
		(new Thread() {
			    public void run(){
				    DatagramSocket socket = null;
				    DatagramPacket packet;
				    
				    try{
					    address = InetAddress.getByName(netaddress);
					}catch(java.net.UnknownHostException e){
						// does nothing
					}

				    try{
				    	socket = new DatagramSocket(portnumber);
				    	myFrame.updateWindow("Connected!");
				    	//socket = new MulticastSocket(portnumber);
						//socket.joinGroup(address);		
				
						byte[] data = new byte[62];
						packet = new DatagramPacket(data,data.length, address, portnumber);
						
						socket.send(packet);
						
					    while (myFrame.isVisible()){
					        // receive the packets
							try{
								socket.receive(packet);
						    }catch(java.io.IOException e){
								// does nothing
						    }
					        String str = new String(packet.getData());
					        myFrame.callData(str);
				    	}  // while
				    	socket.close();
				    }catch(java.io.IOException e){
				    	myFrame.updateWindow("Could not connect: " + e);
				    }
				}
			}
		 ).start();
	
		return;
    }


    public void stop(){
		return;
    }
    
    public void shutdown(boolean exit){
    	this.stop();
    	System.exit(0);
    }

    public void destroy(){
		//window.dispose();
		return;
    }

    public void setTitle(String newTitle)    {
//		if (window != null)
//			window.setTitle(newTitle);
    }
}
